Subject: Re: [Tsvwg] SCTP shutdown

From: Jonathan Wood <[email-masked]>
Date: Wed, 20 Jun 2001 15:28:37 -0700 (PDT)

From RFC 2960 section 9.2 Shutdown of an Association:

   While in SHUTDOWN-SENT state, the SHUTDOWN sender MUST immediately
   respond to each received packet containing one or more DATA chunk(s)
   with a SACK, a SHUTDOWN chunk, and restart the T2-shutdown timer.
   
This generates a lot more traffic than the alternating SACK
method used when in the ESTABLISHED state.

>
>Jonathan,
>
>Well, no.  A SACK is only required with the SHUTDOWN if
>gaps or dups need to be reported.  It is clear in the
>RFC that if there are no gaps or dups there is no need
>to bundle a SACK with a SHUTDOWN.  Now, SHUTDOWN will be
>sent on each received packet, but since the sender of
>the SHUTDOWN is not sending data, these SHUTDOWNs will
>be sent no sooner that a SACK would in a bisymetrical
>flow.  The SHUTDOWN chunk is actually smaller than the
>SACK chunk and requires less processing.  It is actually
>quite efficient: it keeps the ACK clock running and
>consumes less control chunk resources to do so.
>
>--Brian
>
>
>On Wed, 20 Jun 2001, Jonathan Wood wrote:
>
>> >
>> >I don't see any real technical problems with making SCTP operate
>> >in this TCP-compatible mode.  Sounds like a useful socket option.
>> >
>> 
>> Except that each data packet would generate a SACK and a
>> SHUTDOWN chunk. This is a really inefficient way to do
>> half-close. I wouldn't support this sort of functionality.
>> 
>> Jonathan
>> 
>> 
>> _______________________________________________
>> tsvwg mailing list
>> [email-masked]
>> http://www1.ietf.org/mailman/listinfo/tsvwg
>
>-- 
>Brian F. G. Bidulock    ¦ The reasonable man adapts himself to the ¦
>[email-masked]    ¦ world; the unreasonable one persists in  ¦
>http://www.openss7.org/ ¦ trying  to adapt the  world  to himself. ¦
>                        ¦ Therefore  all  progress  depends on the ¦
>                        ¦ unreasonable man. -- George Bernard Shaw ¦

_______________________________________________
tsvwg mailing list
[email-masked]
http://www1.ietf.org/mailman/listinfo/tsvwg

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Wed, 20 Jun 2001 17:55:36 -0500

Jonathan,

But, in contrast RFC 2960 section 6.2 Acknowledgement and
        Reception of DATA Chunks

    Note:  The SHUTDOWN chunk does not contain Gap Ack Block fields.
    Therefore, the endpoint should use a SACK instead of the SHUTDOWN
    chunk to acknowledge DATA chunks received our of order.

Also, further along in section 9.2 Shutdown of an Association:

    The rules in Section 6.3 MUST be followed to determine the proper
    timer value for T2-shutdown.  To indicate any gaps in TSN, the
    endpoint may also bundle a SACK with the SHUTDOWN chunk in the same
    SCTP packet.

So, I think your statements are hardly the last word, even
considering the RFC.  It was always the intention that a SHUTDOWN
be used instead of a SACK to acknowledge received data while in
SHUTDOWN-SENT state (otherwise, who needs the cummulative TSN field?)
The only need to send a SACK is when gaps and dups are encountered
per the citations above.

--Brian